/*
 * Խػ! - ΥեGladeˤäƤޤ.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"

GtkWidget*
create_mainwin ()
{
  GtkWidget *mainwin;
  GtkWidget *screen;

  mainwin = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (mainwin, "mainwin");
  gtk_object_set_data (GTK_OBJECT (mainwin), "mainwin", mainwin);
  gtk_window_set_title (GTK_WINDOW (mainwin), "Information in winter");

  screen = gtk_drawing_area_new ();
  gtk_widget_set_name (screen, "screen");
  gtk_widget_ref (screen);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "screen", screen,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (screen);
  gtk_container_add (GTK_CONTAINER (mainwin), screen);

  gtk_signal_connect (GTK_OBJECT (mainwin), "destroy",
                      GTK_SIGNAL_FUNC (on_mainwin_destroy),
                      NULL);

  return mainwin;
}

