/* =====================================================================

   LiMo - Liblary
      Sync Main System.  - פФ˴Ԥ롼()

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Dec.24.1999  kanon info פդΤǺ
  Dec.25.1999  դ̲ƤۤȤɺȿʤޤ
  Dec.26.1999  -root ɽ빽ѤʤΤǸ󤷤ˤƥ^H^H꡼
  Dec.29.1999  xscreensaver ǵưgetlogin()Ǥݤʤʤˤʤ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RRMainInit          -- ᥤץʤ
  RRMain              -- ֤˥뤵ᥤ
  RRMainFree          -- ᥤץཪλ()
  RRMainWindowSize    -- եå
  RRMainInterval      -- ߻֤
  RRMainIntervalTime  -- ߻֤ɤߤ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <gtk/gtk.h>
#include  "rr_main.h"
#include  "rr_screen.h"
#include  "rr_switch.h"

/* --- եåǡ(椭) */
#include  "../picture/snow.xpm"

/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

#define  INTERVAL   12

/* -------------------------------------------------------------
 --- Structure
-------------------------------------------------------------- */

typedef struct _Snow Snow;

struct _Snow
{
  RRSprite  obj;             /* ץ饤ȥ֥ */
  gint      timer;           /* ɤ餮ѥޡ */
  gint      mx, my;          /* ߤκɸ(8bitդ) */
  gint      ox;              /* ɤ餮ޤʤɸ(̵) */
  gint      sfall;           /* ư® */
  gint      sfreq;           /* ɤ餮® */
  gint      samp;            /* ɤ餮 */
};

/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

void  snow_init(void);
void  disp_snow(gint);
void  disp_winter(gint);
void  next_info(void);


/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- ǥץ쥤ݻ */
static gint  fw, fh;

/* --- ߤγ */
static gint  interval;
static gint  int_handle;

/* --- ǡ */
static GdkPixmap  *pic1;
static GdkBitmap  *mask1;

/* --- ɽ */
static gint  smax = 10;
static gint  sfore;

/* ---  */
static Snow  *object = NULL;

/* --- ɽȥ */
static gchar  comment[256];

/* --- ᥤ롼ץޡ */
static gint  timer;

/* --- ᥤ󥹥ƥå */
static gint  step;

/* --- ᥤ󥹥ƥå */
static gint  mes_step;

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RRMainInit       -- ᥤץʤ

   return : void
   void

-------------------------------------------------------------- */
void RRMainInit(void)
{
  int_handle = 0;

  timer = 0;
  step = 0;
  mes_step = 0;
  srand((unsigned int)time(NULL));

  RRScreenFontSetInit("-adobe-times-bold-r-normal-*-16-*-*-*-*-*-*-*,\
            -*-*-medium-*-normal-*-16-*-*-*-*-*-jisx0208.1983-0");

  /* -- ߳ */
  RRMainInterval(INTERVAL);

  /* -- եå pixmap  */
  if (RRScreenIsRoot() == FALSE) {
    pic1 = gdk_pixmap_create_from_xpm_d(RRScreenWindow()->window,
					&mask1,
					NULL,
					snow_xpm);
    RRScreenSwitch();
  }
  else {
    /* --- root window 餷 */
    pic1 = gdk_pixmap_create_from_xpm_d(RRScreenRoot(),
					&mask1,
					NULL,
					snow_xpm);
    RRScreenSwitchRoot();
  }
  

  /* -- եå pixmap  */
  snow_init();
}


/* -------------------------------------------------------------
  RRMainFree       -- ᥤץཪλ

   return : void
   void

-------------------------------------------------------------- */
void RRMainFree(void)
{
  if (int_handle != 0) gtk_timeout_remove(int_handle);
  if (pic1 != NULL) gdk_pixmap_unref(pic1);
  if (mask1 != NULL) gdk_bitmap_unref(mask1);
  if (object != NULL) g_free(object);
}


/* -------------------------------------------------------------
  RRMainWindowSize   -- եå

   return : void
   void
-------------------------------------------------------------- */
void       RRMainWindowSize(gint w, gint h)
{
  fw = w;
  fh = h;
}


/* -------------------------------------------------------------
  RRMainInterval   -- ߻֤

   return : void
   gint n(n sec)
-------------------------------------------------------------- */
void RRMainInterval(gint n)
{
  if (int_handle != 0) gtk_timeout_remove(int_handle);
  int_handle = gtk_timeout_add(1000/n, (GtkFunction)RRMain, NULL);
  /* --- ͤݻ */
  interval = n;
}


/* -------------------------------------------------------------
  RRMainIntervalTime  -- ߻֤ɤߤ

   return : n (1/n sec)
   void
-------------------------------------------------------------- */
gint RRMainIntervalTime(void)
{
  return(interval);
}


/* -------------------------------------------------------------
  RRMain           -- ֤˥뤵ᥤ

   return : void
   void
-------------------------------------------------------------- */
gint RRMain(gpointer gdata)
{
  /* --- Graphic Buffer Υå */
  if (RRScreenWindow() != NULL) {
    RRScreenSwitch();
  }
  else {
    RRScreenSwitchRoot();
  }
  RRScreenClear(0xffff, 0xffff, 0xffff);

  /* --- ե᡼ɽƥå */
  switch(step) {
  case 0:
    next_info();
    step = 1;
  case 1:
    timer++;
    disp_winter(256 * (timer % 80) / 80);
    if (timer == 79) {
      timer = 0;
      step = 0;
    }
    break;
  }

  return 1;
}





/* -------------------------------------------------------------
  snow_init     -- 㥪֥ν
-------------------------------------------------------------- */
void  snow_init(void)
{
  gint  i, chr;

  /* --- ̥ˤ碌ƹߤ餻̤ */
  smax = 4;
  smax = smax * ((fw / 240) + 1) * ((fh / 180) + 1);
  if (smax < 4) smax = 4;
  /* -- ,ʸˤʤ륹ץåȥʥС() */
  sfore = smax * 3 / 5;
  if (sfore == smax) sfore = smax - 1;
  if (sfore == 0) sfore = 1;
  /* --- ֥꡼γ */
  object = g_malloc0(sizeof(Snow) * smax);

  /* --- ֥ȥѥ᡼ */
  for(i=0; i<smax; i++) {
    chr = 4 * i / smax;
    object[i].timer = (gint)(4096.0 * rand()/(RAND_MAX+1.0));
    object[i].my = (gint)((((gfloat)fh) * rand()/(RAND_MAX+1.0))*256);
    object[i].ox = (gint)(((gfloat)fw) * rand()/(RAND_MAX+1.0));
    object[i].sfall = (chr + 4) * 128;
    object[i].sfreq = ((gint)(4.0 * rand()/(RAND_MAX+1.0))) * 16 + 32;
    object[i].samp = ((gint)(1024.0 * rand()/(RAND_MAX+1.0))) + 256;
    object[i].obj.sw = TRUE;
    object[i].obj.objmap = pic1;
    object[i].obj.objmask = mask1;
    object[i].obj.w = object[i].obj.h = 16;
    object[i].obj.ox = chr * 16;
    object[i].obj.oy = 0;
    object[i].obj.offset_x = object[i].obj.offset_y = 7;
  }
}


/* -------------------------------------------------------------
  disp_snow   -- 
-------------------------------------------------------------- */
void  disp_snow(gint count)
{
  gint  d, w;

  /* --- Ϥ߽Ф夫 */
  if (object[count].my > ((fh+8)*256)) {
    object[count].my = -9 * 256;
    object[count].ox = (gint)(((gfloat)fw) * rand()/(RAND_MAX+1.0));
  }

  /* --- ɤ餮Ⱥɸ */
  object[count].timer++;
  d = object[count].timer % object[count].sfreq;
#ifdef M_PIl
  w = (gint)((double)object[count].samp *
	     sin((2*M_PIl) * (double)d / (double)object[count].sfreq));
#else
  w = (gint)((float)object[count].samp *
	     sin((2*M_PI) * (float)d / (float)object[count].sfreq));
#endif
  object[count].mx = (object[count].ox * 256) + w;
  object[count].my += object[count].sfall;

  /* --- ץ饤ɽ */
  object[count].obj.x = object[count].mx / 256;
  object[count].obj.y = object[count].my / 256;
  RRScreenObjPut(&object[count].obj);
}


/* -------------------------------------------------------------
  disp_winter   -- ¤
-------------------------------------------------------------- */
void  disp_winter(gint count)
{
  gint  i, strw, strh, dy, col;

  count %= 256;

  /* --- ߤ餻ޤ(¦) */
  for(i=0; i<sfore; i++) {
    disp_snow(i);
  }

  /* --- ե᡼ɽ */
  if (comment[0] != (gchar)NULL) {
    if (count < 64) {
      col = 256 * (63 - count) / 64;
    }
    else if (count > 192) {
      col = 256 * (count - 192) / 64;
    }
    else {
      col = 0;
    }
    RRScreenGCColor(col*256, col*256, col*256);
    RRScreenFontSize(comment, &strw, &strh);
    dy = (fh / 6) * count / 256 + (fh / 2) - (fh / 12);
    RRScreenFontLocate(((fw/2)-(strw/2)), dy - (strh/2));
    RRScreenFontPrint(comment);
  }

  /* --- ߤ餻ޤ(¦) */
  for(i=sfore; i<smax; i++) {
    disp_snow(i);
  }
}


/* -------------------------------------------------------------
  next_info   -- ե᡼å
-------------------------------------------------------------- */
void  next_info(void)
{
  switch(mes_step) {
    /* -- å */
  case 0:
    {
      gint t;
	comment[0] = (gchar)NULL;
      t = (gint)(2.0 * rand()/(RAND_MAX+1.0));
      switch(t) {
      case 0:
	mes_step = 1;
	break;
      case 1:
	mes_step = 4;
	break;
      }
      /* --- xscreensaver εưgetlogin()ǽʤΤ */
      if (RRSwitchGetRoot() == TRUE) {
	mes_step = 1;
      }
    }
    break;

    /* -- ߻ɽ */
  case 1:
    strcpy(comment, "줫ɤ줯餤ФäΤ");
    mes_step = 2;
    break;
  
  case 2:
    strcpy(comment, "Ǹ˻פ򸫤ΤϤĤä");
    mes_step = 3;
    break;
  
  case 3:
    {
      time_t tm;
      tm = time(NULL);
      strcpy(comment, ctime(&tm));
    }
    mes_step = 0;
    break;

    /* -- 桼ɽ */
  case 4:
    strcpy(comment, "ɤƥܥϤˤ");
    mes_step = 5;
    break;
  
  case 5:
    strcpy(comment, "ιߤꤷ");
    mes_step = 6;
    break;
  
  case 6:
    strcpy(comment, "ߤϤ졩ܥϡܥϡ");
    mes_step = 7;
    break;
  
  case 7:
    strcpy(comment, "Login user name : ");
    strcat(comment, getlogin());
    mes_step = 0;
    break;

  }
}
